<?PHP
/* $Id: http-logs.php,v 1.4 2001/04/13 09:20:15 bzizou Exp $

Proxy and apache logs

This script is part of the SLIS Project initiated by the CARMI-Internet
(Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
(Acadmie de Grenoble - France 38).

This script have been writen by Bruno Bzeznik - copyright (C) 2001
Ce script  t crit par Bruno Bzeznik - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire.
Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License
along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail
to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  <slis@ac-grenoble.fr>
*/

// loading libs and init
require("../inc/html.inc.php");
require("../inc/lib.inc.php");
require("../inc/pgsql.inc.php");

// HTML head, not if export function is called
if ($export_squid == "" && $export_apache == "") {
  print startHTML("Proxy logs");
}

if ($MAXLINES < 10) { $MAXLINES=60; };



// Functions


function squid_report($begin,$end,$limit,$offset,$count) {	// Print a squid log report between dates $begin and $end, limiting to $limit rows and starting at $offset. 
  // If $count is different than 0, the global variable $sql_count will be updated with the total number of rows for this query.

  global $sql_count,$url,$host;

  // The filters
  $filter="";
  if ($url != "") { $filter .= " and url like '%". $url ."%'"; }
  if ($host != "") { $filter .= " and remotehost like '%". $host ."%'"; }

  if ($count != 0) {

    // SQL query for the count
    $db = dbconnect();
    $query="select count(*)
          from access_squid
          where time>='$begin 00:00:00' and time<='$end 23:59:59'
          $filter
          ";
    $result=pg_exec($db,$query);
    $sql_count=pg_result($result,0,"count");
  }

  // SQL query
  $db = dbconnect();
  $query="select to_char(time,'DD/MM/YYYY HH24:MI:SS') as t,*
          from access_squid
          where time>='$begin 00:00:00' and time<='$end 23:59:59'
          $filter
          order by time
          limit $limit
          offset $offset";

  $result=pg_exec($db,$query);

  $report="";
  for ($i=0;$i<pg_numrows($result);$i++) {
    $report .= pg_result($result,$i,"t") .", ". pg_result($result,$i,"remotehost") .", ". pg_result($result,$i,"url") ."<BR>\n";
  }

  return $report;
}

function apache_report($begin,$end,$limit,$offset,$count) {	// Print an apache log report between dates $begin and $end, limiting to $limit rows and starting at $offset. 
  // If $count is different than 0, the global variable $sql_count will be updated with the total number of rows for this query.

  global $sql_count,$url,$host;

  // The filters
  $filter="";
  if ($url != "") { $filter .= " and request like '%". $url ."%'"; }
  if ($host != "") { $filter .= " and host like '%". $host ."%'"; }

  if ($count != 0) {

    // SQL query for the count
    $db = dbconnect();
    $query="select count(*)
          from access_apache
          where time>='$begin 00:00:00' and time<='$end 23:59:59'
          $filter
          ";
    $result=pg_exec($db,$query);
    $sql_count=pg_result($result,0,"count");
  }

  // SQL query
  $db = dbconnect();
  $query="select to_char(time,'DD/MM/YYYY HH24:MI:SS') as t,*
          from access_apache
          where time>='$begin 00:00:00' and time<='$end 23:59:59'
          $filter
          order by time
          limit $limit
          offset $offset";

  $result=pg_exec($db,$query);

  $report="";
  for ($i=0;$i<pg_numrows($result);$i++) {
    $report .= pg_result($result,$i,"t") .", ". pg_result($result,$i,"host") .", ". pg_result($result,$i,"request") ."<BR>\n";
  }

  return $report;
}



function export_squid($begin,$end) {	// Print a squid log report between dates $begin and $end. 

  global $url,$host;

  // The filters
  $filter="";
  if ($url != "") { $filter .= " and url like '%". $url ."%'"; }
  if ($host != "") { $filter .= " and remotehost like '%". $host ."%'"; }

  // SQL query
  $db = dbconnect();
  $query="select to_char(time,'DD/MM/YYYY HH24:MI:SS') as t,*
          from access_squid
          where time>='$begin 00:00:00' and time<='$end 23:59:59'
          $filter
          order by time";

  $result=pg_exec($db,$query);

  $report="TIME,ELAPSED,REMOTE_HOST,CODE/STATUS,BYTES,METHOD,PEER_STATUS,URL\n";
  for ($i=0;$i<pg_numrows($result);$i++) {
    $report .= "\"". pg_result($result,$i,"t") ."\",";
    $report .= pg_result($result,$i,"elapsed") .",";
    $report .= "\"". pg_result($result,$i,"remotehost") ."\",";
    $report .= "\"". pg_result($result,$i,"code_status") ."\",";
    $report .= pg_result($result,$i,"bytes") .",";
    $report .= "\"". pg_result($result,$i,"method") ."\",";
    $report .= "\"". pg_result($result,$i,"peerstatus") ."\",";
    $report .= "\"". pg_result($result,$i,"url") ."\"\n";
  }

  return $report;
}

function export_apache($begin,$end) {	// Print an apache log report between dates $begin and $end. 

  global $url,$host;

  // The filters
  $filter="";
  if ($url != "") { $filter .= " and request like '%". $url ."%'"; }
  if ($host != "") { $filter .= " and host like '%". $host ."%'"; }

  // SQL query
  $db = dbconnect();
  $query="select to_char(time,'DD/MM/YYYY HH24:MI:SS') as t,*
          from access_apache
          where time>='$begin 00:00:00' and time<='$end 23:59:59'
          $filter
          order by time";

  $result=pg_exec($db,$query);

  $report="TIME,HOST,USER,BYTES,STATUS,REQUEST\n";
  for ($i=0;$i<pg_numrows($result);$i++) {
    $report .= "\"". pg_result($result,$i,"t") ."\",";
    $report .= "\"". pg_result($result,$i,"host") ."\",";
    $report .= "\"". pg_result($result,$i,"user") ."\",";
    $report .= pg_result($result,$i,"bytes") .",";
    $report .= "\"". pg_result($result,$i,"status") ."\",";
    $report .= "\"". pg_result($result,$i,"request") ."\"\n";
  }

  return $report;
}


// MAIN BEGINS HERE

// make the time variables $begin and $end (by default start of the current month to now)
if ($begin_m<1 || $begin_m>12) {
    $begin=date("M-d-Y",time()-2592000);
    $eu_begin=date("d/m/Y",time()-2592000);
}
else {
     if ($begin_d<1 || $begin_d>31) { $begin_d=1; }
     if ($begin_y<1) { $begin_y=1; }
     $begin=date("M-d-Y",mktime(0,0,0,$begin_m,$begin_d,$begin_y));
     $eu_begin=date("d/m/Y",mktime(0,0,0,$begin_m,$begin_d,$begin_y));
}
  if ($end_m<1 || $end_m>12) {
    $end=date("M-d-Y",time());
    $eu_end=date("d/m/Y",time());
}
else {
     if ($end_d<1 || $end_d>31) { $end_d=0; $end_m++; }
          if ($end_y<1) { $end_y=1; }
     $end=date("M-d-Y",mktime(0,0,0,$end_m,$end_d,$end_y));
     $eu_end=date("d/m/Y",mktime(0,0,0,$end_m,$end_d,$end_y));
}



// SQUID REPORT EXPORT
if ($export_squid != "") {
  header("Content-disposition: filename=squid_log.csv \n\n");
  header("Content-type: txt-download/plain \n\n");
  print export_squid($begin,$end);
  exit;
}



// APACHE REPORT EXPORT
if ($export_apache != "") {
  header("Content-disposition: filename=apache_log.csv \n\n");
  header("Content-type: txt-download/plain \n\n");
  print export_apache($begin,$end);
  exit;
}



// SQUID LOGS FORM
if ($action=="index_squid") {

  $text=start_stop_form("http-logs.php","squid-report");
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_stats_Proxy,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}



// APACHE LOGS FORM
if ($action=="index_apache") {

  $text=start_stop_form("http-logs.php","apache-report");
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_stats_Web,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}



// PRINTING THE LOGS
if ($action=="squid-report" || $action=="apache-report") {

  // Style
  print "<style type=\"text/css\">";
  print "//<!--\n";
  print "A:link    { text-decoration: none;}\n";
  print "A:visited { text-decoration: none;}\n";
  print "//-->\n";
  print "</style>\n";

  
  // Initialize offset and count
  if ($offset == "") { $offset = 0; }
  if ($offset != 0) { $count=0; }
  else { $count=1; }

  // Do the report
  if ($action=="squid-report") { $report=squid_report($begin,$end,$MAXLINES,$offset,$count); }
  if ($action=="apache-report") { $report=apache_report($begin,$end,$MAXLINES,$offset,$count); }

  $link="";
  $text="<FONT FACE=HELVETICA,ARIAL>\n";
 
  // Form for searching
  $text .= "<CENTER><FORM ACTION=http-logs.php METHOD=GET>\n";
  $text .= "<FONT FACE=\"HELVETICA,ARIAL\" SIZE=-1>\n";
  $text .= "<INPUT TYPE=HIDDEN NAME=action VALUE=$action>\n";
  $text .= "<INPUT TYPE=HIDDEN NAME=begin_d VALUE=$begin_d>\n";
  $text .= "<INPUT TYPE=HIDDEN NAME=begin_m VALUE=$begin_m>\n";
  $text .= "<INPUT TYPE=HIDDEN NAME=begin_y VALUE=$begin_y>\n";
  $text .= "<INPUT TYPE=HIDDEN NAME=end_d VALUE=$end_d>\n";
  $text .= "<INPUT TYPE=HIDDEN NAME=end_m VALUE=$end_m>\n";
  $text .= "<INPUT TYPE=HIDDEN NAME=end_y VALUE=$end_y>\n";
  $text .= "URL: <INPUT TYPE=TEXT SIZE=10 NAME=url VALUE=$url>\n";
  $text .= "&nbsp;&nbsp;&nbsp;HOST: <INPUT TYPE=TEXT SIZE=10 NAME=host VALUE=$host>\n";
  $text .= "&nbsp;&nbsp;&nbsp;<INPUT TYPE=submit VALUE=$lang_Search>\n";
  if ($action=="squid-report") { 
    $text .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE=submit NAME=export_squid VALUE=$lang_Export>\n";
  }
  if ($action=="apache-report") { 
    $text .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE=submit NAME=export_apache VALUE=$lang_Export>\n";
  }
  $text .= "</FONT></FORM></CENTER>\n";
  $text .= "<HR>\n";


  if ($sql_count > 0) {

    // Calculate the number of pages and curent page
    $last=$offset+$MAXLINES;
    $n_pages=ceil($sql_count/$MAXLINES);
    $cur_page=ceil(($offset/$sql_count)*$n_pages);
    if ($cur_page==0) { $cur_page=1; }

    // Links to other pages
    if ($cur_page != 1) {
      $new_offset=$offset-$MAXLINES;
      $link .= "<A HREF=http-logs.php?action=$action&begin_d=$begin_d&begin_m=$begin_m&begin_y=$begin_y&end_d=$end_d&end_m=$end_m&end_y=$end_y&offset=0&sql_count=$sql_count&url=$url&host=$host>&lt;&lt;</A>&nbsp;&nbsp;&nbsp;";
      $link .= "<A HREF=http-logs.php?action=$action&begin_d=$begin_d&begin_m=$begin_m&begin_y=$begin_y&end_d=$end_d&end_m=$end_m&end_y=$end_y&offset=$new_offset&sql_count=$sql_count&url=$url&host=$host>&lt;</A>";
    }
    else {
      $link .= "&lt;&lt;&nbsp;&nbsp;&nbsp;&lt;";      
    }
    $link .= "&nbsp;&nbsp;&nbsp;&nbsp; $cur_page / $n_pages &nbsp;&nbsp;&nbsp;&nbsp;";

    if ($cur_page != $n_pages) {
      $new_offset=$offset+$MAXLINES;
      $link .= "<A HREF=http-logs.php?action=$action&begin_d=$begin_d&begin_m=$begin_m&begin_y=$begin_y&end_d=$end_d&end_m=$end_m&end_y=$end_y&offset=$new_offset&sql_count=$sql_count&url=$url&host=$host>&gt;</A>&nbsp;&nbsp;&nbsp;";
      $new_offset=$MAXLINES*($n_pages - 1);
      $link .= "<A HREF=http-logs.php?action=$action&begin_d=$begin_d&begin_m=$begin_m&begin_y=$begin_y&end_d=$end_d&end_m=$end_m&end_y=$end_y&offset=$new_offset&sql_count=$sql_count&url=$url&host=$host>&gt;&gt;</A>";
    }
    else {
      $link .= "&gt;&nbsp;&nbsp;&nbsp;&gt;&gt;";
    }
    $text .= "<CENTER>$link</CENTER><P>\n";

    // Printing of the report
    $text .= "<FONT FACE=\"Helvetica,Arial\" SIZE=-1>\n$report</FONT>";
    if ($sql_count > 10) { $text .= "<P><CENTER>$link</CENTER><P>\n"; }
  }
  else {
    $text .= "<CENTER><I>$lang_stats_Report_nodata</I></CENTER>\n";
  }
 
  $text .= "</FONT><BR>\n";

  if ($action == "squid-report") {
    if ($LANGUAGE == "french") { $title = "$lang_stats_Proxy &nbsp; $eu_begin &nbsp; -> &nbsp; $eu_end"; }
    else { $title = "$lang_stats_Proxy &nbsp; $begin &nbsp; -> &nbsp; $end"; }
  }
  if ($action == "apache-report") {
    if ($LANGUAGE == "french") { $title = "$lang_stats_Web &nbsp; $eu_begin &nbsp; -> &nbsp; $eu_end"; }
    else { $title = "$lang_stats_Web &nbsp; $begin &nbsp; -> &nbsp; $end"; }
  }

  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$title,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";
}

?>
