#!/bin/perl
# $Id: slis-sys.inc.pl,v 1.5 2001/04/10 10:16:51 bzizou Exp $ #
#
# Perl include for SLIS system subroutines
#
# This script is part of the SLIS Project initiated by the CARMI-Internet
# (Acadmie de Grenoble - France 38).
# Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
# (Acadmie de Grenoble - France 38).
#
# SLIS : Serveur de communications Linux Pour l'Internet Scolaire.
# Copyright (C) 1998-2001 Bruno Bzeznik
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    You should have received a copy of the GNU General Public License
#    along with this program (For example ./COPYING);
#    if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
#    Cambridge, MA 02139, USA.
#
# Please send all comments and bug reports by electronic mail to:
#   Bruno Bzeznik <Bruno@ac-grenoble.fr>
# or to <slis@ac-grenoble.fr>
#
# Envoyez vos suggestions et reports de bugs par e-mail 
#   Bruno Bzeznik <Bruno@ac-grenoble.fr>
# ou  <slis@ac-grenoble.fr>
#

sub log_err { 		# Log the error of an SQL request: log_err($sth,$msg)

  my $str = $_[0]->errstr;
  if ($str ne "") { syslog('err',$_[1] .": ". $str) };
  return 0;    
}


sub log_msg { 		# Log an str to err: log_msg($msg)

  if ($_[0] ne "") { syslog('err',"ERR: ". $_[0]) };
  return 0;
}


sub clean_conns {	# Clean the "conns" table by deleting values older than one year: clean_conns($sth)

  $sth=$_[0];
  $sth = $dbh->prepare("delete from conns where date_part('days',now()-start)>365");
  $sth->execute;
  log_err($sth,'delete from conns');
}

sub sql_rotate {	# sql_rotate($sth,$table,$date_field,$number_of_days)
			# Clean a table by deleting values where date_field is older than number_of_days
  $sth=$_[0];
  $table=$_[1]; 
  $date=$_[2]; 
  $days=$_[3]; 
  $sth = $dbh->prepare("delete from $table where date_part('days',now()-$date)>$days");
  $sth->execute;
  log_err($sth,"delete from $table");
}
